#version 430 core

layout(location = 1) in vec3 VERTEX_POSITION;
layout(location = 3) uniform mat4 VIEW_POJECTION_MATRIX;
layout(location = 4) uniform mat4 MODEL_MATRIX;
layout(location = 5) uniform mat4 ROTAION_MATRIX;
layout(location = 6) in vec3 VERTEX_NORMAL;
layout(location = 8) uniform float TIME;
layout (location = 9) in vec2 UV_COORDS;
layout(location = 10) uniform vec3 eye;
layout(location = 20) uniform int textureSet;

layout(location = 9) out vec2 uvs;

void main()
{
    gl_Position = MODEL_MATRIX * ROTAION_MATRIX* vec4(VERTEX_POSITION.x, VERTEX_POSITION.y, VERTEX_POSITION.z, 1.0); 
    uvs = UV_COORDS;
}  